const consoleLog = console.log.bind(console)
let isDebug = true;
export default function log () {
  let stackframe = (new Error()).stack.split('\n')
  if (stackframe && stackframe.length > 2) {
    let infoArr = stackframe[2].split("/")
    var file = infoArr[infoArr.length - 1].split(":")[0]
    var line = infoArr[infoArr.length - 1].split(":")[1];
    var append = file +":" + line;
    let className = file.split('.')[0]
    let hash = getHashCode(className) % colors.length
    consoleLog(`%c${append}`, `color: #000; background: ${colors[hash]}`, ...arguments)
  } else {
    console.log(...arguments);
  }

}

const getHashCode = s => s.split('').reduce((prevHash, curChar) => prevHash * 31 + curChar.charCodeAt(0), 0)

export function hookConsoleLog () {
  console.log = log
}

// colors created by enumerating HSL color wheel from 0...360 in 30 degree steps, with luminosity 75 and 90
const colors = ['#ff8080', '#ffcccc', '#ffbf80', '#ffe6cc', '#ffff80', '#ffffcc', '#bfff80', '#e6ffcc', '#80ff80', '#ccffcc', '#80ffbf', '#ccffe6', '#80ffff', '#ccffff', '#80bfff', '#cce5ff', '#8080ff', '#ccccff', '#bf80ff', '#e5ccff', '#ff80ff', '#ffccff', '#ff80bf', '#ffcce6']
